Index: other-projects/hathitrust/wcsa/vol-checker/WebContent/HT-HTRC_Mashup.user.js
===================================================================
--- other-projects/hathitrust/wcsa/vol-checker/WebContent/HT-HTRC_Mashup.user.js	(revision 31330)
+++ other-projects/hathitrust/wcsa/vol-checker/WebContent/HT-HTRC_Mashup.user.js	(revision 31330)
@@ -0,0 +1,210 @@
+// ==UserScript==
+// @name        HT-HTRC Mashup
+// @author      David Bainbridge
+// @namespace   org.hathitrust.researchcenter.mashup
+// @description Hybrid interface between Hathitrust and HTRC
+// @version     1.0
+// @grant       GM_xmlhttpRequest
+// @require     http://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js
+// @match       https://www.hathitrust.org/*
+// @match       https://babel.hathitrust.org/cgi/ls*
+// @match       https://babel.hathitrust.org/cgi/mb*
+// ==/UserScript==
+
+// grant GM_xmlhttpRequest
+// grant GM_getValue
+// grant GM_setValue
+// grant GM_addStyle
+
+
+function mashupInit() {
+
+    var $fieldset = $('form fieldset').first();
+    var $search_button = $fieldset.find('button');
+    $search_button.css("width","47px");
+    $search_button.css("right","-55px");
+    $search_button.css("font-size","95%");
+    $search_button.find('span').first().hide();
+
+    $fieldset.append('<button id="htrc-bw" class="button search" style="width:47px; right: -105px; background-image:url(http://www.cs.waikato.ac.nz/~davidb/htrc-mashup/bookworm.png);" title="Bookworm"></button>');
+
+    var $bw_button = $('#htrc-bw');
+    $bw_button.click(function(event) {
+	var input=$('#q1-input').val();
+	if (input === "") {
+	            return;
+	    }
+	event.preventDefault();
+
+	var url_front = "https://bookworm.htrc.illinois.edu/#?%7B%22counttype%22%3A%22WordsPerMillion%22%2C%22search_limits%22%3A%5B";
+	var url_end   = "%5D%7D";
+
+	var word_front = "%7B%22word%22%3A%5B%22";
+	var word_end   = "%22%5D%2C%22date_year%22%3A%7B%22%24gte%22%3A1750%2C%22%24lte%22%3A1923%7D%7D";
+
+	var input_words = input.split(' ');
+	var word_len = input_words.length;
+
+	var full_url = url_front;
+
+	for (var i=0; i<word_len; i++) {
+	            var word = input_words[i];
+	            if (i>0) { full_url += "%2C"; } // append comma
+	            full_url += word_front + word + word_end;
+	        }
+
+	full_url += url_end;
+
+	// window.location.href = "https://bookworm.htrc.illinois.edu/#?%7B%22search_limits%22%3A%5B%7B%22word%22%3A%5B%22"+input+"%22%5D%2C%22date_year%22%3A%7B%22%24gte%22%3A1750%2C%22%24lte%22%3A1923%7D%7D%5D%7D";
+
+	window.location.href = full_url;
+
+    });
+
+    var url = window.location.href;
+    var home_url_test = url.replace(/^https:\/\/www.hathitrust.org\//,"");
+    //console.log("*** home urltest = " + home_url_test);
+    if (home_url_test !== "") {
+	var $login_button = $('#login-button');
+	if ($login_button.length) {
+	            $login_button.css('font-size','95%');
+	            $login_button.css('right','-45px');
+	            $login_button.css('width','80px');
+	        }
+    }
+
+
+
+    /*
+    each(function() {
+
+    $('form button').each(function() {
+    console.log("*** this = " + this + "jquery this = " + $(this).val());
+    });
+    */
+
+
+}
+
+function mashupAugmentResults()
+{
+    //console.log("**** mashupAugmentResults() called");
+    var $results_a = $('#results_A');
+    var results_a_exists = $results_a.length;
+
+    if (!results_a_exists) {
+	// Not a main search result page
+	// => See if part of the collections page area
+	// => If it is, set things up so it will use that instead
+	    $results_a = $('#form1');
+	    results_a_exists = $results_a.length;
+    }
+
+    if (results_a_exists) {
+	//console.log("*** results_a = " + $results_a.html());
+
+	var ids = [];
+	//var file_safe_ids = [];
+
+	$results_a.find('.result').each(function() {
+	            var $result_access_link = $(this).find('.result-access-link');
+	            console.log("*** result access link = " + $result_access_link.html());
+
+	            var $id_link = $result_access_link.find('ul>li>a').first();
+	            //console.log("*** id_link = " + $id_link.html());
+	            var data_clicklog = $id_link.attr("data_clicklog");
+	            //console.log("*** data clicklog= " + data_clicklog);
+
+	            var data_json_str = data_clicklog.replace(/^[a-z]+\|/,"");
+	            //console.log("*** data json= " + data_json_str);
+
+	            var id = null;
+	            if (data_json_str !== "") {
+			    var data_json = JSON.parse(data_json_str);
+			    id = data_json.id;
+			    //console.log("*** (catalog extracted) id= '" + id + "'");
+			        }
+	            else {
+			    var $second_id_link = $result_access_link.find('ul>li>a').eq(1);
+			    console.log("*** 2nd link len = " + $second_id_link);
+			    var id_href = $second_id_link.attr("href");
+			    console.log("*** id href = " + id_href);
+			    id = id_href.replace(/^.*id=/,"");
+			        }
+
+	            ids.push(id);
+	            //var file_safe_id = id.replace(/:/g,"+").replace(/\//g,"=");
+	            //file_safe_ids.push(file_safe_id);
+
+	            $result_access_link.attr("id","htrc-mashup-" + id);
+	            //$result_access_link.attr("id","htrc-mashup-" + file_safe_id);
+
+	        });
+
+	var ids_str = ids.join(",");
+	//var file_safe_ids_str = file_safe_ids.join(",");
+
+	//console.log("*** ids= " + JSON.stringify(ids));
+	//console.log("*** ids_str = " + ids_str);
+
+	console.log("**** Away to request: " + "http://bedrock.resnet.cms.waikato.ac.nz:8686/vol-checker/VolumeCheck?ids=" + encodeURIComponent(ids_str));
+
+
+
+
+	GM_xmlhttpRequest ({
+	            method: "GET",
+	            url: "http://bedrock.resnet.cms.waikato.ac.nz:8686/vol-checker/VolumeCheck?ids=" + encodeURIComponent(ids_str),
+	            //url: "http://localhost:8080/htrc-ef-exists/VolumeCheck?ids=" + encodeURIComponent(file_safe_ids_str),
+	            //headers: {
+	        //"Content-Type": "application/x-www-form-urlencoded"
+	          //  },
+	            onload: function (response) {
+
+			    console.log("Adding in HTRC cross-checks");
+			    var text = response.responseText;
+			    //console.log ( "Response text: " + text);
+			    var ids_exist = JSON.parse(text);
+
+			    for (var k in ids_exist) {
+				    //console.log("*** k = '" + k + "'");
+
+				    //var id_str = '#htrc-mashup-'+k;
+				    //console.log("*** id str = " + id_str);
+				    // var $id_div = $(id_str);
+
+				    //var $id_div = $('#'+'htrc-mashup-'+k);
+				    var id_div = document.getElementById('htrc-mashup-'+k);
+				    //console.log("*** id_div = " + id_div);
+				    var $id_div = $(id_div);
+
+				    if (ids_exist[k]) {
+					$id_div.find("ul").append("<li title=\""+k+"\" style=\"color: #924a0b;\"><a>Download Extracted Features</a></li>"); // â
+					    }
+				    else {
+					// â, â
+					$id_div.find("ul").append("<li title=\""+k+"\" style=\"color: red;\">HTRC unfriendly â</li>");
+					    }
+
+				    //console.log("*** id div len = " + $id_div.length);
+
+				    //$.append("<li>HTRC friendly</li>");
+				    /*
+				                if (ids_exist.hasOwnProperty(k)) {
+						  //console.log("*** processing id: " + k);
+						    //$('#htrc-mashup-'+k).css("background-color:","red");
+						      $('#htrc-mashup-'+k).append("<p>HTRC friendly</p>");
+						            }*/
+				}
+
+			        }
+	        });
+
+	//console.log("*** GM httpRequest made ");
+    }
+}
+
+mashupInit();
+
+mashupAugmentResults();
+
Index: other-projects/hathitrust/wcsa/vol-checker/WebContent/index.html
===================================================================
--- other-projects/hathitrust/wcsa/vol-checker/WebContent/index.html	(revision 31330)
+++ other-projects/hathitrust/wcsa/vol-checker/WebContent/index.html	(revision 31330)
@@ -0,0 +1,447 @@
+<!DOCTYPE html>
+<html>
+  <head>
+    <base href="https://analytics.hathitrust.org/" />    
+        <title>HTRC Mashup - Home </title>
+        <link rel="shortcut icon" href="/assets/images/favicon.ico"/>
+        <meta name="viewport" content="width=device-width, initial-scale=1.0">
+        <meta http-equiv="refresh" content="600">
+            <!-- Bootstrap -->
+        <link href="/assets/stylesheets/bootstrap.min.css" rel="stylesheet" media="screen">
+        <link href="/assets/stylesheets/main.css" rel="stylesheet" media="screen">
+        <link href="/assets/stylesheets/flat.css" rel="stylesheet" media="screen">
+        <link href="/assets/stylesheets/font-awesome.min.css" rel="stylesheet">
+        <link href="/assets/stylesheets/tomorrow.min.css" rel="stylesheet">
+        
+        <link rel="stylesheet" href="/theme">
+        
+        <script src="/assets/javascripts/highlight.min.js"></script>
+        <script src="/assets/javascripts/jquery.min.js"></script>
+        <script src="/assets/javascripts/stupidtable.min.js"></script>
+        <script src="/assets/javascripts/bootstrap.min.js"></script>
+        <script src="/assets/javascripts/bowser.min.js"></script>
+        <script type="text/javascript" src="/assets/javascripts/htrcwarnings.js"></script>
+        <script type="text/javascript" src="/assets/javascripts/uploadws.js"></script>
+        <script type="text/javascript" src="/assets/javascripts/ga-download-tracking.js"></script>
+
+  </head>
+  <body>
+        <nav class="navbar navbar-default navbar-fixed-top navbar-htrc" role="navigation">
+            <div class="container">
+                <div class="navbar-header">
+                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1">
+                        <span class="sr-only">Toggle navigation</span>
+                        <span class="icon-bar"></span>
+                        <span class="icon-bar"></span>
+                        <span class="icon-bar"></span>
+                    </button>
+                    <a class="navbar-brand" href="/"><img src="/assets/images/hathi.jpg"
+                    width="36" height="32" style="padding-right : 5 px ; margin-top : - 1 px ;" alt=" ">
+                        HTRC Portal
+                    </a>
+                </div>
+
+                <div class="navbar-collapse collapse">
+                    <ul class="nav navbar-nav">
+                        <li><a href="/">Home</a></li>
+                        </li>
+
+                        <li class="dropdown">
+                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                Worksets <b class="caret"></b></a>
+                            <ul class="dropdown-menu">
+                                
+                                    <li><a href="#" onclick="loggingRequiredWarning('/listuserworksets')" >View my worksets</a></li>
+                                
+                                <li class="divider"></li>
+                                
+                                    <li><a href="#" onclick="loggingRequiredWarning('/listallworksets')">View all worksets</a></li>
+                                
+                                <li class="divider"></li>
+                                
+                                    <li><a href="#" onclick="loggingRequiredWarning('/uploadworkset')">Upload workset</a></li>
+                                
+                                <li class="divider"></li>
+                                <li>
+                                    <a href="#" onclick="blacklightLoggingWarning ( '      https://analytics.hathitrust.org/blacklight ')">
+                                        Create workset</a>
+                                </li>
+                            </ul>
+                        </li>
+                        
+                            <li><a href="#" onclick="loggingRequiredWarning('/listalgorithms')" >Algorithms</a></li>
+                        
+                        
+                            <li><a href="#" onclick="loggingRequiredWarning('/listjobs')">Results</a></li>
+                        
+                        
+                            <li class="dropdown">
+                                <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                    Capsule<b class="caret"></b></a>
+                                <ul class="dropdown-menu">
+                                    <li><a href="https://wiki.htrc.illinois.edu/display/COM/HTRC+Data+Capsule">
+                                        Documentation</a>
+                                    </li>
+                                    <li class="divider"></li>
+                                    
+                                        <li><a href="#" onclick="loggingRequiredWarning('/listvms')" >
+                                            Show Capsules</a></li>
+                                    
+                                    <li class="divider"></li>
+                                    
+                                        <li><a href="#" onclick="loggingRequiredWarning('/createvms')" >
+                                            Create Capsule</a></li>
+                                    
+                                </ul>
+                            </li>
+                        
+                        <li class="dropdown">
+                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                Data<b class="caret"></b></a>
+                            <ul class="dropdown-menu">
+                                <li><a href="/features">
+                                    Extracted Features Dataset</a>
+                                </li>
+                                <li><a href="/genre">
+                                    Word Frequencies in English-Language Literature, 1700-1922</a>
+                                </li>
+                            </ul>
+                        </li>
+                        <li class="dropdown">
+                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                Help<b class="caret"></b></a>
+                            <ul class="dropdown-menu">
+                                <li><a href="https://wiki.htrc.illinois.edu/display/COM/HTRC+User+Getting+Started+FAQ">
+                                    Knowledge Base</a>
+                                </li>
+                                <li class="divider"></li>
+                                <li><a href="mailto:htrc-help@hathitrust.org?Subject=Contact">
+                                    Contact</a>
+                                </li>
+                            </ul>
+                        </li>
+                        <li><a href="/about">About</a>
+                    </ul>
+                    
+                        <ul class="nav pull-right navbar-nav">
+                            <li class="dropdown">
+                                <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                    Sign In<b class="caret"></b></a>
+                                <ul class="dropdown-menu">
+                                    <li><a href="/login">Sign In</a></li>
+                                    <li class="divider"></li>
+                                    <li><a href="/passwordresetmail">
+                                        Forgot Password?</a></li>
+                                </ul>
+                            </li>
+
+
+                            <li><a href="/signup"><span>Sign Up</span></a></li>
+                        </ul>
+                    
+                </div>
+                    <!--/.nav-collapse -->
+            </div>
+        </nav>
+        
+        
+
+    <div class="container container-panel" style="padding-top: 15px; padding-bottom: 15px;">
+        <div class="row">
+            <div class="col-md-2 col-sm-2 hidden-xs">
+                <img class="img-responsive"  src="/assets/images/hathi.jpg" alt=" ">
+            </div>
+            <div class="col-md-10 col-sm-10 col-xs-12 col-lg-8" style="margin-left: 0;">
+                <h1 style="font-weight:bold;font-size:56px">
+                    HT + HTRC Mashup
+                </h1>
+            </div>
+        </div>
+        <div class="row" style="padding-top : 25px; font-size : 17px; line-height : 27px;">
+            <div class="col-md-12">
+
+
+
+     <h2>Overview</h2>
+
+     <p>
+       Installing the software provided through this web page 
+       allows you to mashup HTRC's
+       Bookworm and Extracted Features data-set with the main
+       HathiTrust web site.  Once the software is installed
+       when you next visit 
+       <a href="http://www.hathitrust.org">www.hathitrust.org</a> 
+       you will notice a few additional features:
+     </p>
+     <ul>
+       <li><b>Bookwork Button.</b> Next to the
+	 regular search button there will now also be a button 
+	 with a worm icon on it.  Having entered some terms 
+	 into the search box, you now have a choice: pressing
+	 the magnifying search button to initiate a regular
+	 search within the HathiTrust DL, or else pressing this 
+	 new button next to it to initiate a bookworm search
+	 with the terms you have just entered.
+       </li>
+       <li><b>Extracted Features Integration.</b> Along side
+	 links for 
+         <a class="cataloglinkhref icomoon-info-circle">Catalog Record</a>
+	 and
+         <a class="fulltext icomoon-document-2">Full view</a>
+	 for volumes/documents in the interface, there will additional be links for
+	 <a class="cataloglinkhref">Download Extracted Features</a>.
+	 You find these links appearing in search result sets, and when
+	 browsing the items that make up publically available collections.
+	 While most HT volumes have an extracted feature counterpart
+	 in HTRC, due to the on-going expansion of the content of the
+	 HathiTrust, not all of them do.  In such circumstances the
+	 Mashup software marks these entries
+	 as <a style"color:red">HTRC Unfriendly</a>.
+
+       </li>
+
+       <li><b>HT Collection to HTRC Workset.</b>In the collectcions
+	 area of the HathiTrust it is possible to <a>Download metadata</a>
+	 for the currently selected collectcion.  Now an additional download
+	 button is available&mdash;Collection to Workset&mdash;that 
+	 downloads the same metadata, but filtered to those that are 
+	 available as extracted features in the HTRC.
+     </ul>
+
+      <h2>Installation</h2>
+
+      <p>
+	To try out this HT + HTRC Mashup you need to have 
+<!--
+	<a href="https://wiki.greasespot.net/Cross-browser_userscripting">
+	<a href="https://wiki.greasespot.net/User_script">
+-->
+        <a href="https://github.com/OpenUserJs/OpenUserJS.org/wiki/Userscript-beginners-HOWTO">
+	  user-scripting
+	</a>
+	enabled in your browser.  This is a two-step process:
+	<ol>
+	  <li>
+	    Install a user-script manager extension/add-in to your web browser such
+	    as 
+	    <a href="https://addons.mozilla.org/en-US/firefox/addon/greasemonkey/">
+	      GreaseMonkey
+	    </a> (Firefox)
+	    or 
+	    <a href="https://tampermonkey.net/">TamperMonkey</a> (other browsers: Chrome, Microsoft Edge, Safari, Opera etc.).
+	    The former is the add-in, developed for Firefox, that became
+	    the catalyst for the more general idea of user-scripting in
+	    browsers.  The latter is a project that has put emphasis on
+	    being cross-browser compatible.
+	    
+	  </li>
+	  <li>
+	    Add the HT+HTRC Mashup Script to your user-scripting extension/add-in:
+	    <ul>
+	      <a name="download"/>
+	      <li>
+		<a href="http://bedrock.resnet.cms.waikato.ac.nz:8686/vol-checker/HT-HTRC_Mashup.user.js">
+		  Version 1.0
+		</a>
+	      </li>
+	    </ul>
+	</ol>
+
+<!--
+      <p>The script was developed as a GreaseMonkey user-script for Firefox, and is known
+	to also work in Chrome, Internet Explorer, Opera, and Safari but the set up can be a bit more
+	involved.  
+      </p>
+
+      <p>
+	This integrated functionality is achieved through user scripting
+	in your web browser.  There are two things you need to install:
+      
+
+Userscripts.org
+
+	If you are interested in trying out CSN with the minimum of
+	fuss, we recommend you
+	install <a href="https://addons.mozilla.org/en-US/firefox/addon/greasemonkey/">GreaseMonkey</a>
+	in <a href="http://www.mozilla.org/en-US/firefox/new/">Firefox</a>
+	(if you do not already have it installed), restart the web
+	browser and then click on the
+	<a href="#download">above link</a> to download the CSN script.  This will trigger
+	GreaseMonkey's mechanism for installing user-scripts.  
+      </p>
+
+-->
+
+      <p>
+	Now visit <a href="http://www.hathitrust.org">www.hathitrust.org</a> and
+	look out for the additional buttons and links!
+
+      </p>
+
+
+<!--
+	I hope you find the extension useful!
+      <p>
+	<i>
+	    <a href="http://www.cs.waikato.ac.nz/~davidb/">David Bainbridge</a><br />
+	      <a href="http://www.cs.waikato.ac.nz/">Department of Computer Science</a><br />
+	          University of Waikato<br />
+	          New Zealand<br />
+	      </i>
+      </p>
+
+      <hr />
+-->
+
+
+
+	    </div>
+        </div>
+
+	<!--
+       <div class="row">
+            <div class="col-md-12" style="margin-top : 20px;">
+                <h2 style="margin-top : 0">What would you like to do today?</h2>
+            </div>
+        </div>
+
+        <div class="row">
+            <div class="col-md-3">
+                <div class="panel panel-default panel-htrc margin-bt-0">
+                    <div class="panel-heading">
+                        <a href="#" class="dropdown-toggle" data-toggle="dropdown" onclick="blacklightLoggingWarning('https://analytics.hathitrust.org/blacklight')">Create Workset</a>
+                    </div>
+                    <div class="panel-body">
+                        <div class="text-content">Create workset using our workset builder.</div>
+                     </div>
+                </div>
+            </div>
+            <div class="col-md-3">
+                <div class="panel panel-default panel-htrc margin-bt-0">
+                    <div class="panel-heading">
+                        
+                            <a href="#" onclick="loggingRequiredWarning('/uploadworkset')">Upload Workset</a>
+                        
+                    </div>
+                    <div class="panel-body">
+
+                        <div class="text-content">Upload a workset by specifying the
+                            necessary data about its volumes through a text file.</div>
+                        </div>
+                </div>
+            </div>
+            <div class="col-md-3">
+                <div class="panel panel-default panel-htrc margin-bt-0">
+                    <div class="panel-heading">
+                        
+                            <a href="#" onclick="loggingRequiredWarning('/listallworksets')">Browse Workset</a>
+                        
+                    </div>
+                    <div class="panel-body">
+                        <div class="text-content">Browse through already created worksets.</div>
+                    </div>
+                </div>
+            </div>
+            <div class="col-md-3">
+                <div class="panel panel-default panel-htrc margin-bt-0">
+                    <div class="panel-heading">
+                        
+                            <a href="#" onclick="loggingRequiredWarning('/listalgorithms')">Execute Algorithms</a>
+                        
+                    </div>
+                    <div class="panel-body">
+
+                                    <div class="text-content">Select and execute
+                                        text analysis algorithms for word count to more sophisticated
+                                        approaches.</div>
+
+                    </div>
+                </div>
+            </div>
+	
+        </div>
+	-->
+
+    </div>
+
+
+	
+        <div class="container">
+        <p style="text-align: center; font-size: small; margin-top: 10px;">HTRC Portal (<a href="https://wiki.htrc.illinois.edu/display/COM/HTRC+Service+Release+v3.1+for+Uncamp+2015" target="_blank">v3.2.x</a>)
+        </p>
+        </div>
+
+        
+        <div id="push"></div>
+        
+        
+        
+        
+        
+        
+        
+        
+        
+        
+        <div class="modal fade" id="create-collection-modal" aria-hidden="true" tabindex="-1" role="dialog">
+            <div class="modal-dialog">
+                <div class="modal-content">
+                    <div class="modal-header">
+                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
+                        <h4 class="modal-title">Create Workset</h4>
+                    </div>
+                    <div class="modal-body">
+                        <p>You are being redirected to the Workset Builder.
+                            If this is the first time accessing it during this browser session,
+                            you will need to select "Login" from the top-right menu bar before creating or modifying a workset.
+                            We are aware this is inconvenient and we're working on a technical solution to eliminate this requirement.</p>
+                    </div>
+                    <div class="modal-footer">
+                        <span class="pull-left" style="padding-top : 5 px ;"><input type="checkbox" id="dont-show" style="margin : - 3 px 0 0 ;">
+                            Don't Show This Again.</span>
+                        <a href="#" class="btn btn-link btn-sm" data-dismiss="modal" aria-hidden="true">Cancel</a>
+                        <a id="modal-wb-url" href="" class="btn btn-sm btn-primary" onclick="goToCreateCollection ( )">
+                            Go</a>
+                    </div>
+                </div>
+            </div>
+        </div>
+        <div class="modal fade" id="login-required-modal" aria-hidden="true" tabindex="-1" role="dialog">
+            <div class="modal-dialog">
+                <div class="modal-content">
+                    <div class="modal-header">
+                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
+                        <h4 class="modal-title">Please Sign in</h4>
+                    </div>
+                    <div class="modal-body">
+                        <p>You need to sign in to access this functionality.</p>
+                    </div>
+                    <div class="modal-footer">
+                        
+                        
+                        <a href="#" class="btn btn-link btn-sm" data-dismiss="modal" aria-hidden="true">Cancel</a>
+                        <a id="modal-target-url" href="" data-toggle="modal" class="btn btn-sm btn-primary">
+                            Go</a>
+                    </div>
+                </div>
+            </div>
+        </div>
+
+	<!--
+        <script>
+            (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
+            (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
+            m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
+            })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
+
+            ga('create', 'UA-42842720-8', 'auto');
+            ga('send', 'pageview');
+        </script>
+	-->
+	
+  </body>
+
+
+
+</html>
+