Index: /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-zookeeper-start.sh
===================================================================
--- /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-zookeeper-start.sh	(revision 31366)
+++ /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-zookeeper-start.sh	(revision 31367)
@@ -1,3 +1,5 @@
 #!/bin/bash
 
-ssh gchead zkServer.sh start
+zookeeper_host=${ZOOKEEPER_SERVER%:*}
+
+ssh $zookeeper_host zkServer.sh start
Index: /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-zookeeper-stop.sh
===================================================================
--- /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-zookeeper-stop.sh	(revision 31366)
+++ /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-zookeeper-stop.sh	(revision 31367)
@@ -1,3 +1,5 @@
 #!/bin/bash
 
-ssh gchead zkServer.sh stop
+zookeeper_host=${ZOOKEEPER_SERVER%:*}
+
+ssh $zookeeper_host zkServer.sh stop
Index: /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SETUP.bash
===================================================================
--- /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SETUP.bash	(revision 31366)
+++ /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SETUP.bash	(revision 31367)
@@ -11,5 +11,11 @@
   export ZOOKEEPER_SERVER=localhost:8181
   export SOLR_NODES="localhost:8983 localhost:8984 localhost:8985 localhost:8986 localhost:8987 localhost:8988 localhost:8989 localhost:8990 localhost:8991 localhost:8992"
-else 
+  
+elif [ "${short_hostname%[1-2]}" = "solr" ] ; then
+  export ZOOKEEPER_SERVER=solr1:8181
+  export SOLR_NODES="solr1:8983 solr1:8984 solr1:8985 solr1:8986 solr1:8987"
+  export SOLR_NODES="$SOLR_NODES solr2:8983 solr2:8984 solr2:8985 solr2:8986 solr:8987"
+
+else
   export ZOOKEEPER_SERVER=gchead:8181
   export SOLR_NODES="gc0:8983 gc1:8983 gc2:8983 gc3:8983 gc4:8983 gc5:8983 gc6:8983 gc7:8983 gc8:8983 gc9:8983"
@@ -17,5 +23,5 @@
 fi
 
-if [ "$short_hostname" != "nema" ] ; then
+if [ "$short_hostname" != "nema" ] && [ "${short_hostname%[1-2]}" != "solr" ] ; then
   HDFS_HEAD=hdfs://gchead:9000
 fi
@@ -34,5 +40,10 @@
 fi
 
-export JAVA_HOME="$HTRC_EF_NETWORK_HOME/jdk1.8.0"
+if [ "${short_hostname%[1-2]}" = "solr" ] ; then
+  export JAVA_HOME="/usr/lib/jvm/j2sdk1.8-oracle"
+else
+  export JAVA_HOME="$HTRC_EF_NETWORK_HOME/jdk1.8.0"
+fi
+
 export PATH="$JAVA_HOME/bin:$PATH"
 #export _JAVA_OPTIONS="-Xmx512m"
@@ -46,5 +57,5 @@
 fi
 
-if [ "$short_hostname" != "nema" ] ; then
+if [ "$short_hostname" != "nema" ] && [ "${short_hostname%[1-2]}" != "solr" ] ; then
   source SETUP/setup-spark.bash
 fi
@@ -53,18 +64,20 @@
 source SETUP/setup-solr.bash
 
-export MONGODB_CONFIG_HOSTS="gc0 gc1 gc2"
-export MONGODB_CONFIG_PORT="27019"
+if [ "$short_hostname" = "gsliscluster1" ] ; then
+  export MONGODB_CONFIG_HOSTS="gc0 gc1 gc2"
+  export MONGODB_CONFIG_PORT="27019"
 
-export MONGODB_ROUTER_HOSTS="gc3 gc4 gc5"
-export MONGODB_ROUTER_PORT="27017"
+  export MONGODB_ROUTER_HOSTS="gc3 gc4 gc5"
+  export MONGODB_ROUTER_PORT="27017"
 
-export MONGODB_REPLSET1_HOSTS="gc6 gc7"
-export MONGODB_REPLSET2_HOSTS="gc8 gc9"
-export MONGODB_REPLSET_PORT="27017"
-##export MONGODB_REPLSET_ARRAY=("$MONGODB_REPLSET1_HOSTS" "$MONGODB_REPLSET2_HOSTS")
-export MONGODB_REPLSET_METALIST="MONGODB_REPLSET1_HOSTS MONGODB_REPLSET2_HOSTS"
-export MONGODB_SHARD_HOSTS="$MONGODB_REPLSET1_HOSTS $MONGODB_REPLSET2_HOSTS"
+  export MONGODB_REPLSET1_HOSTS="gc6 gc7"
+  export MONGODB_REPLSET2_HOSTS="gc8 gc9"
+  export MONGODB_REPLSET_PORT="27017"
+  ##export MONGODB_REPLSET_ARRAY=("$MONGODB_REPLSET1_HOSTS" "$MONGODB_REPLSET2_HOSTS")
+  export MONGODB_REPLSET_METALIST="MONGODB_REPLSET1_HOSTS MONGODB_REPLSET2_HOSTS"
+  export MONGODB_SHARD_HOSTS="$MONGODB_REPLSET1_HOSTS $MONGODB_REPLSET2_HOSTS"
 
-source SETUP/setup-mongodb.bash
+  source SETUP/setup-mongodb.bash
+fi
 
 export PATH="$HTRC_EF_NETWORK_HOME/SCRIPTS:$PATH"
@@ -73,5 +86,5 @@
 fi
 
-if [ "$short_hostname" != "nema" ] ; then
+if [ "$short_hostname" != "nema" ] && [ "${short_hostname%[1-2]}" != "solr" ] ; then    
   spark_conf_slaves="$SPARK_HOME/conf/slaves" 
   if [ ! -f "$spark_conf_slaves" ] ; then