Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/da-ddt.map
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/da-ddt.map	(revision 31376)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/da-ddt.map	(revision 31376)
@@ -0,0 +1,25 @@
+AC	NUM
+AN	ADJ
+AO	NUM
+CC	CONJ
+CS	CONJ
+I	X
+NC	NOUN
+NP	NOUN
+PC	PRON
+PD	PRON
+PI	PRON
+PO	PRON
+PP	PRON
+PT	PRON
+RG	ADV
+SP	ADP
+U	PRT
+VA	VERB
+VE	VERB
+XA	X
+XF	X
+XP	.
+XR	X
+XS	.
+XX	X
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/de-tiger.map
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/de-tiger.map	(revision 31376)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/de-tiger.map	(revision 31376)
@@ -0,0 +1,54 @@
+$(	.
+$,	.
+$.	.
+ADJA	ADJ
+ADJD	ADJ
+ADV	ADV
+APPO	ADP
+APPR	ADP
+APPRART	ADP
+APZR	ADP
+ART	DET
+CARD	NUM
+FM	X
+ITJ	X
+KOKOM	CONJ
+KON	CONJ
+KOUI	CONJ
+KOUS	CONJ
+NE	NOUN
+NN	NOUN
+NNE	NOUN
+PDAT	PRON
+PDS	PRON
+PIAT	PRON
+PIS	PRON
+PPER	PRON
+PPOSAT	PRON
+PPOSS	PRON
+PRELAT	PRON
+PRELS	PRON
+PRF	PRON
+PROAV	PRON
+PTKA	PRT
+PTKANT	PRT
+PTKNEG	PRT
+PTKVZ	PRT
+PTKZU	PRT
+PWAT	PRON
+PWAV	PRON
+PWS	PRON
+TRUNC	X
+VAFIN	VERB
+VAIMP	VERB
+VAINF	VERB
+VAPP	VERB
+VMFIN	VERB
+VMINF	VERB
+VMPP	VERB
+VVFIN	VERB
+VVIMP	VERB
+VVINF	VERB
+VVIZU	VERB
+VVPP	VERB
+XY	X
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/en-ptb.map
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/en-ptb.map	(revision 31376)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/en-ptb.map	(revision 31376)
@@ -0,0 +1,68 @@
+!	.
+#	.
+$	.
+''	.
+(	.
+)	.
+,	.
+-LRB-	.
+-RRB-	.
+.	.
+:	.
+?	.
+CC	CONJ
+CD	NUM
+CD|RB	X
+DT	DET
+EX	DET
+FW	X
+IN	ADP
+IN|RP	ADP
+JJ	ADJ
+JJR	ADJ
+JJRJR	ADJ
+JJS	ADJ
+JJ|RB	ADJ
+JJ|VBG	ADJ
+LS	X
+MD	VERB
+NN	NOUN
+NNP	NOUN
+NNPS	NOUN
+NNS	NOUN
+NN|NNS	NOUN
+NN|SYM	NOUN
+NN|VBG	NOUN
+NP	NOUN
+PDT	DET
+POS	PRT
+PRP	PRON
+PRP$	PRON
+PRP|VBP	PRON
+PRT	PRT
+RB	ADV
+RBR	ADV
+RBS	ADV
+RB|RP	ADV
+RB|VBG	ADV
+RN	X
+RP	PRT
+SYM	X
+TO	PRT
+UH	X
+VB	VERB
+VBD	VERB
+VBD|VBN	VERB
+VBG	VERB
+VBG|NN	VERB
+VBN	VERB
+VBP	VERB
+VBP|TO	VERB
+VBZ	VERB
+VP	VERB
+WDT	DET
+WH	X
+WP	PRON
+WP$	PRON
+WRB	ADV
+``	.
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/nl-alpino.map
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/nl-alpino.map	(revision 31376)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/nl-alpino.map	(revision 31376)
@@ -0,0 +1,12 @@
+Adj	ADJ
+Adv	ADV
+Art	DET
+Conj	CONJ
+Int	X
+Misc	X
+N	NOUN
+Num	NUM
+Prep	ADP
+Pron	PRON
+Punc	.
+V	VERB
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/pt-bosque.map
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/pt-bosque.map	(revision 31376)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/pt-bosque.map	(revision 31376)
@@ -0,0 +1,22 @@
+?	.
+adj	ADJ
+adv	ADV
+art	DET
+conj-c	CONJ
+conj-s	CONJ
+ec	X
+in	X
+n	NOUN
+num	NUM
+pp	NOUN
+pron-det	PRON
+pron-indp	PRON
+pron-pers	PRON
+prop	NOUN
+prp	ADP
+punc	.
+v-fin	VERB
+v-ger	VERB
+v-inf	VERB
+v-pcp	VERB
+vp	VERB
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/se-talbanken.map
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/se-talbanken.map	(revision 31376)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/opennlp-lang-pos-mappings/se-talbanken.map	(revision 31376)
@@ -0,0 +1,41 @@
+++	CONJ
+AB	ADV
+AJ	ADJ
+AN	NOUN
+AV	VERB
+BV	VERB
+EN	NUM
+FV	VERB
+GV	VERB
+HV	VERB
+I?	.
+IC	.
+ID	X
+IG	.
+IK	.
+IM	PRT
+IP	.
+IQ	.
+IR	.
+IS	.
+IT	.
+IU	.
+KV	VERB
+MN	NOUN
+MV	VERB
+NN	NOUN
+PN	NOUN
+PO	PRON
+PR	ADP
+PU	.
+QV	VERB
+RO	NUM
+SP	VERB
+SV	VERB
+TP	VERB
+UK	CONJ
+VN	NOUN
+VV	VERB
+WV	VERB
+XX	X
+YY	X